<?php

//check if maintenance is on
if(!is_file("/var/tmp/fd-maint.yes")){
    print "Server not in maintenance, exit\n";
    exit();
}

if(!is_file("/usr/sbin/rabbitmqctl")){
    print "Rabbitmqctl not found, exit\n";
    exit();
}

$total_messages = 0;
$total_messages_unack = 0;

$cmd = "/usr/sbin/rabbitmqctl list_queues messages messages_unacknowledged";
exec($cmd,$res);
foreach($res as $line) {
    $line = explode("\t", $line);
    if(count($line)<2){
        continue;
    }
    $total_messages += intval($line[0]);
    $total_messages_unack += intval($line[1]);
}
if($total_messages == 0){
    print "No messages\n";
    exit();
}
$ratio = round($total_messages_unack/$total_messages,2);
if($ratio < 0.5 ){
    print "Ratio too low [$ratio|$total_messages|$total_messages_unack]\n";
    exit();
}

$cmd = "rabbitmqctl list_channels name messages_unacknowledged  | grep -v '\s0'";
exec($cmd,$res);

$i=0;
foreach($res as $line){

    print $line."\n";
    $line = explode(" ",$line);

    $i++;
    if($i==1){
        continue;
    }

    if(count($line)<3){
        continue;
    }

    $tmp = explode(":",$line[2]);
    $port = array_pop($tmp);
    $ip_from = array_shift($tmp);

    $tmp2 = explode(":",$line[0]);
    $ip_to = array_shift($tmp2);


    $cmd2 = "ss -K '( sport = :".$port." )' src ".$ip_from." dst ".$ip_to;
    print $cmd2."\n";

    exec($cmd2);
}

?>
